var premissions = {
  checkPermissions: function (permissions, cb) {
    if (!cb) {
      cb = permissions; 
      permissions = settings.permissions;
    }
    chrome.permissions.contains(permissions, function (contains) {
      if (contains) {
        cb();
      } else {
        premissions.requestPermissions(cb);
      }
    });
  },
  requestPermissions: function (permissions, cb) {
    if (!cb) { 
      cb = permissions; 
      permissions = settings.permissions; 
    }
    chrome.permissions.request(permissions, function (granted) {
      if (granted) {
        cb();
      } else {
        premissions.requestPermissionsFailed();
      }
    });
  },
  removePermissions: function () {
    chrome.permissions.remove(settings.permissions);
  },
  requestPermissionsFailed: function () {
    console.log("request permission failed.");
  }
};