var popup = {
  ready: function () {
    $(".capture-visible").click(popup.captureVisible);
    $(".capture-all").click(popup.captureAll);
    $(".capture-region").click(popup.captureRegion);
    $(".capture-clipboard").click(popup.captureClipboard);
    $(".blank-canvas").click(popup.paintbrush);
    $(".edit-content").click(popup.editContent);
    $(".settings").click(() => {
      chrome.runtime.openOptionsPage();
    });
    $("#working, #message").click(function () {
      $(this).fadeOut();
    });
    $(".ver").text(extension.version);
  },
  paintbrush: () => {
    var backgroundWindow = chrome.extension.getBackgroundPage();
    with (backgroundWindow) {
      if (!screenshot.canvas) {
        screenshot.canvas = document.createElement("canvas");
      }

      screenshot.canvas.width = window.screen.availWidth - 50;
      screenshot.canvas.height = window.screen.availHeight - 250;
      var ctx = screenshot.canvas.getContext("2d");
      ctx.beginPath();
      ctx.rect(0, 0, screenshot.canvas.width, screenshot.canvas.height);
      ctx.fillStyle = "white";
      ctx.fill();
    }
    chrome.tabs.create({
      url: chrome.extension.getURL("editor.html") + "#last",
    });
  },
  notifyTabsForStorageUpdate: function () {
    chrome.extension
      .getBackgroundPage()
      .codeinjector.executeCodeOnAllTabs("extStorageUpdate()");
  },

  checkSupport: function () {
    chrome.tabs.query({ active: true, currentWindow: true }, function (t) {
      t = t[0];
      var url = t.url;
      if (
        url.indexOf("chrome://") >= 0 ||
        url.indexOf("chrome-extension:") >= 0 ||
        url.indexOf("https://chrome.google.com") >= 0
      ) {
        popup.disableScrollSupport();
      }
      if (url.indexOf("file:") == 0) {
        var scriptNotLoaded = setTimeout(popup.disableScrollSupport, 500);
        chrome.tabs.sendMessage(
          t.id,
          {
            type: "checkExist",
          },
          function () {
            if (chrome.runtime.lastError) {
              $("#noall")
                .html(
                  'Go to chrome://extensions, and check the box "Allow access to file URLs"'
                )
                .css({
                  cursor: "pointer",
                  color: "blue",
                  textDecoration: "underline",
                })
                .click(function () {
                  premissions.checkPermissions(
                    { origins: ["<all_urls>"] },
                    function (a) {
                      chrome.tabs.create({
                        url:
                          "chrome://extensions?id=akgpcdalpfphjmfifkmfbpdmgdmeeaeo",
                      });
                    }
                  );
                });
            } else {
              clearTimeout(scriptNotLoaded);
            }
          }
        );
      }
    });
  },

  disableScrollSupport: function () {
    $(".capture-all").hide();
    $(".capture-region").hide();
    $(".edit-content").hide();
    $("#noall").show();
  },
  
  /**
   * Function execution from remote scripts such as background.js
   * @param data
   */
  exec: function (data) {
    $("#working").fadeOut();
    $("#message").fadeOut();
    switch (data.type) {
      case "working":
        $("#working").fadeIn();
        break;
      case "message":
        $("#message")
          .fadeIn()
          .find(".message-container")
          .text(data.message);
        break;
      default:
        console.warn("Invalid message", data);
    }
  },
  captureVisible: function () {
    popup.sendMessage({
      data: "captureVisible",
    });
  },
  captureAll: function () {
    popup.sendMessage({
      data: "captureAll",
    });
  },
  captureRegion: function () {
    popup.sendMessage({
      data: "captureRegion",
    });
  },
  captureClipboard: function () {
    popup.sendMessage({
      data: "captureClipboard",
    });
  },
  editContent: function () {
    popup.sendMessage({
      data: "editContent",
    });
  },
  sendMessage: function (data) {
    chrome.runtime.sendMessage(data, function (x) {
      console.warn("popup_fail", x);
    });
  },
};
$(popup.ready);
